/*

Hi,
This is a fairly simple respawn system. It looks more complex than it actually is.
It's far from flawless, but if you've never done a respawn system it's a good starting point.

Feel free to use this in any way you want, except please don't try and pass it off as your demo.

Enjoy.
-DarkView

*/

mob
	var
		dead = 0			//Used to see if the mob is dead or not.
		rLocX
		rLocY
		rLocZ				//The x, y and z co-ordinates to respawn at.
		respawnSpeed = 30	//How soon after death the monster will respawn.

	//These are just the generic versions of the Die() and Respawn() procs that normal mobs use.
	//The monsters use another version, so this will only be used by players.
	//In short when they die they'll be sent to 1,1,1 on the map straight away.
	proc
		Die()
			if(src.dead)
				return 0
			src.dead = 1
			Respawn()
		Respawn()
			src.loc = locate(1,1,1)
			src.dead = 0

mob/monster
	New()
		. = ..()
		spawn(1)
								//Spawn(1)ing out means that this will happen one tick after the spawn() is activated (with the rest of the New() proc continuing like normal).
								//It's like sleep(), but waits and does the indented stuff when the time is up, without stopping the rest of the proc.
								//This means that by the time the following indented stuff is activated New() will have finished, and the monster will be on the map.
			src.rLocX = src.x
			src.rLocY = src.y
			src.rLocZ = src.z
								//Now we've got a copy of the current x, y and z co-ordinates stored on the monster, so it knows where to respawn.

	Die()
		if(src.dead)
								//If they're already dead we don't want this happening again (otherwise it could lead to several monsters respawning everytime a monster is killed, which would flood the world).
								//We'll return which will stop the proc without doing the rest.
			return
		src.dead = 1			//Set their dead flag so that from now on everything knows it's dead.
		src.loc = null			//This will make them dissapear from the map by setting their location to nothing.
		//Do normal stuff like adding exp to the person who killed it.
		Respawn()
		del(src)				//Now we're done with the monster we can delete it.

	Respawn()
								//By the time we respawn src will be deleted, so we need to store the type and respawn co-ordinates elsewhere.
		var/newMonsterType = src.type
		var/X = src.rLocX
		var/Y = src.rLocY
		var/Z = src.rLocZ
		var/rSpeed = src.respawnSpeed
		src = null				//This will make it so that even after the monster (src) is deleted the proc will continue.
								//Make sure to do this AFTER you've got all the info you need from src, because if you try to access src's vars after you've set it to null you'll get run-time errors.

		spawn(rSpeed)			//Wait however many ticks respawnSpeed is set to, then do the following indented code.
								//While waiting, the rest of the non-indented code will continue like normal.
								//Because there's nothing after it, the Respawn() proc will return and back in the Die() proc src will be deleted.
			new newMonsterType (locate(X, Y, Z))
								//Create a new monster of the same type at the rLocs.